﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.Generic;

namespace SelectAllTest
{
    public class CustomDictionary<TKey, TValue>
    {
        public CustomDictionary()
        {

        }

        public CustomDictionary(Dictionary<TKey, TValue> dictionary)
        {
            m_Dictionary = dictionary;
        }

        private Dictionary<TKey, TValue> m_Dictionary = new Dictionary<TKey, TValue>();

        public Dictionary<TKey, TValue> Dictionary
        {
            get { return m_Dictionary; }
            set { m_Dictionary = value; }
        }

        public TValue this[TKey key]
        {
            get
            {
                if (this.m_Dictionary.ContainsKey(key))
                {
                    return this.m_Dictionary[key];
                }
                else
                {
                    if (!typeof(TValue).IsValueType)
                    {
                        return (TValue)Activator.CreateInstance(typeof(TValue));
                    }

                    return default(TValue);
                }
            }
        }

        public Dictionary<TKey, TValue>.KeyCollection Keys
        {
            get
            {
                return m_Dictionary.Keys;
            }
        }

        public Dictionary<TKey, TValue>.ValueCollection Values
        {
            get
            {
                return m_Dictionary.Values;
            }
        }

        public CustomDictionary<TKey, TValue> Self
        {
            get
            {
                return this;
            }
        }

        public void Add(TKey key, TValue value)
        {
            m_Dictionary.Add(key, value);
        }
    }
}