﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Controls.Grids;
using Infragistics.Controls.Grids.Primitives;

namespace SelectAllTest
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
                        
            ViewModel viewModel = new ViewModel();
            this.DataContext = viewModel;

            this.m_MainGrid.ColumnLayoutAssigned += 
                new EventHandler<ColumnLayoutAssignedEventArgs>(m_MainGrid_ColumnLayoutAssigned);
        }

        void m_MainGrid_ColumnLayoutAssigned(object sender, ColumnLayoutAssignedEventArgs e)
        {
            if (e.Key == "LinkUsers" && e.Rows.Any() && e.Rows[0] is Row)
            {
                var row = (Row)e.Rows[0];
                var parentRow = ((ChildBand)row.ParentRow).ParentRow;
                var parentCellModel = parentRow.Data as User;
                if (null != parentCellModel && 0 < parentCellModel.LinkUsers.Count)
                {
                    e.ColumnLayout = new ColumnLayout { Key = e.Key, AutoGenerateColumns = false };

                    TextColumn newTextColumn = new TextColumn();
                    newTextColumn.HeaderText = "Name";
                    newTextColumn.Key = "Name";

                    e.ColumnLayout.Columns.Add(newTextColumn);

                    GroupColumn newGroupColumn = new GroupColumn();
                    newGroupColumn.HeaderText = "Type";
                    newGroupColumn.Key = "Type";

                    TextColumn ageTextColumn = new TextColumn();
                    ageTextColumn.HeaderText = "Age";
                    ageTextColumn.Key = "UserInfos[Type].Self[Age]";

                    newGroupColumn.Columns.Add(ageTextColumn);

                    TextColumn sexTextColumn = new TextColumn();
                    sexTextColumn.HeaderText = "Sex";
                    sexTextColumn.Key = "UserInfos[Type].Self[Sex]";

                    newGroupColumn.Columns.Add(sexTextColumn);

                    e.ColumnLayout.Columns.Add(newGroupColumn);
                }
            }
        }

        private void CreateColumn()
        {
            this.m_MainGrid.Columns.Clear();
                        
            TextColumn newTextColumn = new TextColumn();
            newTextColumn.HeaderText = "Name";
            newTextColumn.Key = "Name";

            this.m_MainGrid.Columns.Add(newTextColumn);            

            GroupColumn newGroupColumn = new GroupColumn();
            newGroupColumn.HeaderText = "Type";
            newGroupColumn.Key = "Type";
                        
            TextColumn ageTextColumn = new TextColumn();
            ageTextColumn.HeaderText = "Age";
            ageTextColumn.Key = "UserInfos[Type].Self[Age]";

            newGroupColumn.Columns.Add(ageTextColumn);

            TextColumn sexTextColumn = new TextColumn();
            sexTextColumn.HeaderText = "Sex";
            sexTextColumn.Key = "UserInfos[Type].Self[Sex]";

            newGroupColumn.Columns.Add(sexTextColumn);

            this.m_MainGrid.Columns.Add(newGroupColumn);
                        
            ColumnLayout layout = new ColumnLayout();
            layout.Key = "LinkUsers";
            //If not add the layout, the problem not happen, 
            //but We need the layout to display the link information.
            this.m_MainGrid.Columns.Add(layout);
        }

        private void Data_Load(object sender, RoutedEventArgs e)
        {
            this.CreateColumn();
        }

        private void GetData_Collection(object sender, RoutedEventArgs e)
        {
            PagingLocation pagingLocation = m_MainGrid.PagerSettings.AllowPaging;
            if (m_MainGrid.PagerSettings.AllowPaging != PagingLocation.None)
            {
                m_MainGrid.PagerSettings.AllowPaging = PagingLocation.None;
            }
                        
            CustomSelection customSelection = new CustomSelection();
            for (int i = 0; i < this.m_MainGrid.Rows.Count; i++)
            {
                if (!this.m_MainGrid.Rows[i].IsSelected)
                {
                    customSelection.AddSelectItem(this.m_MainGrid.Rows[i]);
                }
            }

            this.m_MainGrid.SelectionSettings.SelectedRows.Clear();
            this.m_MainGrid.SelectionSettings.SelectedRows.AddRange(customSelection);

            if (pagingLocation != PagingLocation.None)
            {
                m_MainGrid.PagerSettings.AllowPaging = pagingLocation;
            }
        }
    }

    public class CustomSelection : SelectedRowsCollection
    {
        public void AddSelectItem(Row r)
        {
            if (!r.IsSelected)
            {
                this.SelectItem(r, true);
            }
        }

        public void RemoveSelectItem(Row r)
        {
            if (r.IsSelected)
            {
                this.SelectItem(r, false);
            }
        }
    }
}
