﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections;
using System.ComponentModel;
using System.Collections.ObjectModel;
using Infragistics.Controls.Grids;
using System.Collections.Generic;

namespace SelectAllTest
{
    public class ViewModel : INotifyPropertyChanged
    {
        private IEnumerable m_BindingItemSource;
        public IEnumerable BindingItemSource
        {
            get
            {
                return m_BindingItemSource;
            }
            set
            {
                m_BindingItemSource = value;
                OnPropertyChanged("BindingItemSource");
            }
        }

        public ViewModel()
        {
            this.GenerateData();
        }

        private void GenerateData()
        {
            ObservableCollection<User> users = new ObservableCollection<User>();
            for (int i = 0; i < 100000; i++)
            {
                User user = new User() { Name = "Name" + i.ToString() };
                user.UserInfos = this.GetUserInfo(i);

                user.LinkUsers = new ObservableCollection<User>();
                if (i == 4)
                {
                    user.LinkUsers.Add(users[1]);
                }
                else if (i == 5)
                {
                    user.LinkUsers.Add(users[2]);
                }
                else if (i == 6)
                {
                    user.LinkUsers.Add(users[3]);
                }

                users.Add(user);
            }

            BindingItemSource = users;
        }

        private CustomDictionary<string, CustomDictionary<string, double?>> GetUserInfo(int index)
        {
            CustomDictionary<string, CustomDictionary<string, double?>> userInfos
                                = new CustomDictionary<string, CustomDictionary<string, double?>>();
            CustomDictionary<string, double?> info1 = new CustomDictionary<string, double?>();
            info1.Add("Age", index);
            info1.Add("Sex", index);
            userInfos.Add("Type", info1);

            return userInfos;
        }      


        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        #endregion
    }
}
